/*****************************************************************************
    Ethernet packet sniffer - GreedyDog2

    Developed by Shadow Penguin Security Resarch Group
     http://www.shadowpenguin.org
     UNYUN <unyun@shadowpenguin.org>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 *****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <malloc.h>

int snprintf(char *buf,int len,char *fmt,...)
{
	va_list argp;
	int     res;
	char    *p;
	FILE    *fp;

	va_start(argp,fmt);
	fp=fopen("/dev/null","w");
	res=vfprintf(fp,fmt,argp);
	fclose(fp);
	va_end(argp);
	if (res<=0) return(res);
	if ((p=malloc(res+1))==NULL) return(-1);
	vsprintf(p,fmt,argp);
	strncpy(buf,p,len);
	buf[len-1]='\0';
	free(p);
	return(res);
}
